﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace Model.Common
{
    public class DataAccess
    {
        //connetion string
        static string conn = ConfigurationManager.ConnectionStrings["OnlineFloralShopConnection"].ConnectionString;
        public DataAccess()
        {
            //
            // TODO: Add constructor logic here
            //
        }


        public static DataTable GetAllCustomers()
        {
            return GetData(null, null, "GetAllCustomers");
        }

        public static DataTable GetAllOrders()
        {
            return GetData(null, null, "GetAllOrders");
        }

        
        //------------------------------------------------------------------------------------------//
        //Method insert, update using procedure RETURN ExecuteNonQuery()
        //String[] paraName: name of parameter
        //object[] paramValue: value of parameter
        //procedureName: name of procedures in database     
        public static int InsertUpdate(String[] paramName, object[] paramValue, string procedureName)
        {

            try
            {
                //connection
                SqlConnection con = new SqlConnection(conn);
                con.Open();
                using (con)
                {

                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = con;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.CommandText = procedureName;


                    if (paramName != null)
                    {
                        //Param Procedure
                        SqlParameter[] param = new SqlParameter[paramName.Length];
                        //Add parameter into param array
                        for (int i = 0; i < paramName.Length; i++)
                        {
                            param[i] = new SqlParameter(paramName[i], paramValue[i]);
                        }

                        //Add parameter for procedure
                        cmd.Parameters.AddRange(param);

                    }
                    //return result (int) value
                    return cmd.ExecuteNonQuery();

                }
            }
            catch
            {
                return 0;
            }

        }


        //------------------------------------------------------------------------------------------//
        //Method select results using procedure RETURN DataSet
        //String[] paraName: name of parameter
        //object[] paramValue: value of parameter
        //procedureName: name of procedures in database
        public static DataTable GetData(String[] paramName, object[] paramValue, string procedureName)
        {
            DataTable dt = new DataTable();
            try
            {
                //connection
                SqlConnection con = new SqlConnection(conn);
                con.Open();
                using (con)
                {

                    SqlCommand cmd = new SqlCommand();
                    cmd.Connection = con;
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.CommandText = procedureName;

                    if (paramName != null)
                    {
                        //Param Procedure
                        SqlParameter[] param = new SqlParameter[paramName.Length];
                        //Add parameter into param array
                        for (int i = 0; i < paramName.Length; i++)
                        {
                            param[i] = new SqlParameter(paramName[i], paramValue[i]);
                        }
                        //Add parameter for procedure
                        cmd.Parameters.AddRange(param);
                    }
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    //Fill data to DataSet
                    da.Fill(dt);

                    //return result (DataSet) value
                    return dt;


                }
            }
            catch
            {
                return dt;
            }

        }
    }
}
